#include <iostream>
#include <set>
#include <vector>
using namespace std;

int main() {
    vector<pair<string, string>> uzytkownicy;
    set<string> nazwy;
    string pseudonimA, pseudonimB;
    while (cin >> pseudonimA) {
        cin >> pseudonimB;
        uzytkownicy.push_back({pseudonimA, pseudonimB});
        nazwy.insert(pseudonimA);
        nazwy.insert(pseudonimB);
    }
    // Zadanie 4.1, liczba użytkowników w serwisie. Można też posortować wszystkie
    // elementy tablicy i usunąć duplikaty.
    cout << "4.1 Wszystkich użytkowników jest: " << nazwy.size() << endl;
    // Zadanie 4.2 Znaleźć wierzchołki o stopniu 0 ("fejki")
    set<string> fejki;
    for (int i = 0; i < uzytkownicy.size(); i++) {
        string ktos = uzytkownicy[i].first;
        // czy jest przez kogoś obserwowany?
        bool byl = false;
        for (auto &para : uzytkownicy) {
            if (para.second == ktos) {
                byl = true;
            }
        }
        if (!byl) {
            fejki.insert(ktos);
        }
    }
    cout << "4.2 Fejkowe konta to: ";
    for (auto fejk : fejki) {
        cout << fejk << " ";
    }
    cout << endl;

    // Zadanie 4.3 Ile kont się obserwuje nawzajem?
    int ile_par = 0;
    for (auto krawedz : uzytkownicy) {
        for (auto kandydat : uzytkownicy) {
            if (krawedz.first == kandydat.second && krawedz.second == kandydat.first) {
                ile_par++;
            }
        }
    }
    // Każda para jest zliczona dwa razy
    cout << "4.3 Par użytkowników obserwujących się nazwajem jest " << ile_par/2 << endl;

    // Zadanie 4.4 Które konto obserwuje największą liczbę użytkowników?
    vector<pair<int, string>> obserwowani;
    for (string konto : nazwy) {
        int ile = 0;
        for (auto krawedz : uzytkownicy) {
            if (krawedz.first == konto) ile++;
        }
        obserwowani.push_back({ile, konto});
    }
    sort(obserwowani.begin(), obserwowani.end());
    cout << "4.4 Konto które obserwuje największą liczbę kont to: " <<
            obserwowani[obserwowani.size() - 1].second << endl;

    // Zadanie 4.5 Najpopularniejsze konto nie uzwględniając fejków
    vector<pair<int, string>> obserwujacy;
    for (string konto : nazwy) {
        int ile = 0;
        for (auto krawedz : uzytkownicy) {
            // Jest obserwowane i nie przez fejka
            if (krawedz.second == konto && fejki.count(krawedz.first) == 0) ile++;
        }
        obserwujacy.push_back({ile, konto});
    }
    sort(obserwujacy.begin(), obserwujacy.end());
    cout << "4.5 Najpopularniejsze konto nie uzwględniając fejków: " <<
        obserwujacy[obserwujacy.size() - 1].second << endl;
    return 0;
}
